Index: /palm/trunk/UTIL/inifor/src/inifor_transform.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_transform.f90	(revision 3866)
@@ -1079,130 +1084,130 @@
 !> iii(:) and jjj(:).
 !------------------------------------------------------------------------------!
-    SUBROUTINE find_vertical_neighbours_and_weights_average(                   &
-       avg_grid, level_based_averaging                                         &
-    )
-
-       TYPE(grid_definition), INTENT(INOUT), TARGET ::  avg_grid
-       LOGICAL                                      ::  level_based_averaging
-
-       INTEGER           ::  i, j, k_palm, k_intermediate, l, nlev
-       LOGICAL           ::  point_is_below_grid, point_is_above_grid,         &
-                             point_is_in_current_cell
-       REAL(dp)          ::  current_height, column_base, column_top, h_top,   &
-                             h_bottom, weight
-       REAL(dp), POINTER ::  cosmo_h(:,:,:)
-
-
-       avg_grid % k_min = LBOUND(avg_grid % z, 1)
-
-       nlev = SIZE(avg_grid % cosmo_h, 3)
+ SUBROUTINE find_vertical_neighbours_and_weights_average(                   &
+    avg_grid, level_based_averaging                                         &
+ )
+
+    TYPE(grid_definition), INTENT(INOUT), TARGET ::  avg_grid
+    LOGICAL                                      ::  level_based_averaging
+
+    INTEGER           ::  i, j, k_palm, k_intermediate, l, nlev
+    LOGICAL           ::  point_is_below_grid, point_is_above_grid,         &
+                          point_is_in_current_cell
+    REAL(wp)          ::  current_height, column_base, column_top, h_top,   &
+                          h_bottom, weight
+    REAL(wp), POINTER ::  cosmo_h(:,:,:)
+
+
+    avg_grid%k_min = LBOUND(avg_grid%z, 1)
+
+    nlev = SIZE(avg_grid%cosmo_h, 3)
+
+    IF (level_based_averaging)  THEN
+       cosmo_h => avg_grid%h
+    ELSE
+       cosmo_h => avg_grid%cosmo_h
+    ENDIF
+
+!
+!-- in each column of the fine grid, find vertical neighbours of every cell
+    DO  l = 1, avg_grid%n_columns
 
        IF (level_based_averaging)  THEN
-          cosmo_h => avg_grid % h
+          i = 1
+          j = 1
        ELSE
-          cosmo_h => avg_grid % cosmo_h
+          i = avg_grid%iii(l)
+          j = avg_grid%jjj(l)
        ENDIF
 
-!
-!--    in each column of the fine grid, find vertical neighbours of every cell
-       DO l = 1, avg_grid % n_columns
-
-          IF (level_based_averaging)  THEN
-             i = 1
-             j = 1
+       column_base = cosmo_h(i,j,1)
+       column_top  = cosmo_h(i,j,nlev)
+
+!
+!--    scan through avg_grid column until and set neighbour indices in
+!--    case current_height is either below column_base, in the current
+!--    cell, or above column_top. Keep increasing current cell index until
+!--    the current cell overlaps with the current_height.
+       k_intermediate = 1 !avg_grid%cosmo_h is indezed 1-based.
+       DO  k_palm = 1, avg_grid%nz
+
+!
+!--       Memorize the top and bottom boundaries of the coarse cell and the
+!--       current height within it
+          current_height = avg_grid%z(k_palm) + avg_grid%z0
+          h_top    = cosmo_h(i,j,k_intermediate+1)
+          h_bottom = cosmo_h(i,j,k_intermediate)
+
+!
+!--       COSMO column top is located at 22000m, point_is_above_grid is very
+!--       unlikely.
+          point_is_above_grid = (current_height > column_top)
+          point_is_below_grid = (current_height < column_base)
+
+          point_is_in_current_cell = (                                      &
+             current_height >= h_bottom .AND.                               &
+             current_height <  h_top                                        &
+          )
+
+!
+!--       set default weights
+          avg_grid%w(l,k_palm,1:2) = 0.0_wp
+
+          IF (point_is_above_grid)  THEN
+
+             avg_grid%kkk(l,k_palm,1:2) = nlev
+             avg_grid%w(l,k_palm,1:2) = - 2.0_wp
+
+             message = "PALM-4U grid extends above COSMO-DE model top."
+             CALL inifor_abort('find_vertical_neighbours_and_weights_average', message)
+
+          ELSE IF (point_is_below_grid)  THEN
+
+             avg_grid%kkk(l,k_palm,1:2) = 0
+             avg_grid%w(l,k_palm,1:2) = - 2.0_wp
+             avg_grid%k_min = MAX(k_palm + 1, avg_grid%k_min)
           ELSE
-             i = avg_grid % iii(l)
-             j = avg_grid % jjj(l)
+!
+!--          cycle through intermediate levels until current
+!--          intermediate-grid cell overlaps with current_height
+             DO  WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
+                k_intermediate = k_intermediate + 1
+
+                h_top    = cosmo_h(i,j,k_intermediate+1)
+                h_bottom = cosmo_h(i,j,k_intermediate)
+                point_is_in_current_cell = (                                &
+                   current_height >= h_bottom .AND.                         &
+                   current_height <  h_top                                  &
+                )
+             ENDDO
+
+!
+!--          k_intermediate = 48 indicates the last section (indices 48 and 49), i.e.
+!--          k_intermediate = 49 is not the beginning of a valid cell.
+             IF (k_intermediate > nlev-1)  THEN
+                message = "Index " // TRIM(str(k_intermediate)) //          &
+                          " is above intermediate grid range."
+                CALL inifor_abort('find_vertical_neighbours', message)
+             ENDIF
+   
+             avg_grid%kkk(l,k_palm,1) = k_intermediate
+             avg_grid%kkk(l,k_palm,2) = k_intermediate + 1
+
+!
+!--          compute vertical weights
+             weight = (h_top - current_height) / (h_top - h_bottom)
+             avg_grid%w(l,k_palm,1) = weight
+             avg_grid%w(l,k_palm,2) = 1.0_wp - weight
           ENDIF
 
-          column_base = cosmo_h(i,j,1)
-          column_top  = cosmo_h(i,j,nlev)
-
-!
-!--       scan through avg_grid column until and set neighbour indices in
-!--       case current_height is either below column_base, in the current
-!--       cell, or above column_top. Keep increasing current cell index until
-!--       the current cell overlaps with the current_height.
-          k_intermediate = 1 !avg_grid % cosmo_h is indezed 1-based.
-          DO k_palm = 1, avg_grid % nz
-
-!
-!--          Memorize the top and bottom boundaries of the coarse cell and the
-!--          current height within it
-             current_height = avg_grid % z(k_palm) + avg_grid % z0
-             h_top    = cosmo_h(i,j,k_intermediate+1)
-             h_bottom = cosmo_h(i,j,k_intermediate)
-
-!
-!--          COSMO column top is located at 22000m, point_is_above_grid is very
-!--          unlikely.
-             point_is_above_grid = (current_height > column_top)
-             point_is_below_grid = (current_height < column_base)
-
-             point_is_in_current_cell = (                                      &
-                current_height >= h_bottom .AND.                               &
-                current_height <  h_top                                        &
-             )
-
-!
-!--          set default weights
-             avg_grid % w(l,k_palm,1:2) = 0.0_dp
-
-             IF (point_is_above_grid)  THEN
-
-                avg_grid % kkk(l,k_palm,1:2) = nlev
-                avg_grid % w(l,k_palm,1:2) = - 2.0_dp
-
-                message = "PALM-4U grid extends above COSMO-DE model top."
-                CALL inifor_abort('find_vertical_neighbours_and_weights_average', message)
-
-             ELSE IF (point_is_below_grid)  THEN
-
-                avg_grid % kkk(l,k_palm,1:2) = 0
-                avg_grid % w(l,k_palm,1:2) = - 2.0_dp
-                avg_grid % k_min = MAX(k_palm + 1, avg_grid % k_min)
-             ELSE
-!
-!--             cycle through intermediate levels until current
-!--             intermediate-grid cell overlaps with current_height
-                DO WHILE (.NOT. point_is_in_current_cell .AND. k_intermediate <= nlev-1)
-                   k_intermediate = k_intermediate + 1
-
-                   h_top    = cosmo_h(i,j,k_intermediate+1)
-                   h_bottom = cosmo_h(i,j,k_intermediate)
-                   point_is_in_current_cell = (                                &
-                      current_height >= h_bottom .AND.                         &
-                      current_height <  h_top                                  &
-                   )
-                ENDDO
-
-!
-!--             k_intermediate = 48 indicates the last section (indices 48 and 49), i.e.
-!--             k_intermediate = 49 is not the beginning of a valid cell.
-                IF (k_intermediate > nlev-1)  THEN
-                   message = "Index " // TRIM(str(k_intermediate)) //          &
-                             " is above intermediate grid range."
-                   CALL inifor_abort('find_vertical_neighbours', message)
-                ENDIF
-   
-                avg_grid % kkk(l,k_palm,1) = k_intermediate
-                avg_grid % kkk(l,k_palm,2) = k_intermediate + 1
-
-!
-!--             compute vertical weights
-                weight = (h_top - current_height) / (h_top - h_bottom)
-                avg_grid % w(l,k_palm,1) = weight
-                avg_grid % w(l,k_palm,2) = 1.0_dp - weight
-             ENDIF
-
-!
-!--       Loop over PALM levels k
-          ENDDO
-
-!
-!--       Loop over averaging columns l
+!
+!--    Loop over PALM levels k
        ENDDO
+
+!
+!--    Loop over averaging columns l
+    ENDDO
  
-    END SUBROUTINE find_vertical_neighbours_and_weights_average
+ END SUBROUTINE find_vertical_neighbours_and_weights_average
 
 !------------------------------------------------------------------------------!
@@ -1215,19 +1220,19 @@
 !> Input parameters:
 !> -----------------
-!> palm_grid % clon : longitudes of PALM-4U scalars (cell centres) in COSMO-DE's rotated-pole grid [rad]
-!>
-!> palm_grid % clat : latitudes of PALM-4U cell centres in COSMO-DE's rotated-pole grid [rad]
-!>
-!> cosmo_grid % lon : rotated-pole longitudes of scalars (cell centres) of the COSMO-DE grid [rad] 
-!>
-!> cosmo_grid % lat : rotated-pole latitudes of scalars (cell centers) of the COSMO-DE grid [rad]
-!>
-!> cosmo_grid % dxi : inverse grid spacing in the first dimension [m^-1]
-!>
-!> cosmo_grid % dyi : inverse grid spacing in the second dimension [m^-1]
+!> palm_grid%clon : longitudes of PALM-4U scalars (cell centres) in COSMO-DE's rotated-pole grid [rad]
+!>
+!> palm_grid%clat : latitudes of PALM-4U cell centres in COSMO-DE's rotated-pole grid [rad]
+!>
+!> cosmo_grid%lon : rotated-pole longitudes of scalars (cell centres) of the COSMO-DE grid [rad] 
+!>
+!> cosmo_grid%lat : rotated-pole latitudes of scalars (cell centers) of the COSMO-DE grid [rad]
+!>
+!> cosmo_grid%dxi : inverse grid spacing in the first dimension [m^-1]
+!>
+!> cosmo_grid%dyi : inverse grid spacing in the second dimension [m^-1]
 !>
 !> Output parameters:
 !> ------------------
-!> palm_grid % w_horiz(:,:,1-4) : weights for bilinear horizontal interpolation
+!> palm_grid%w_horiz(:,:,1-4) : weights for bilinear horizontal interpolation
 !
 !                               COSMO-DE grid
@@ -1251,51 +1256,51 @@
 !          
 !------------------------------------------------------------------------------!
-    SUBROUTINE compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,         &
-       palm_clat, palm_clon, palm_ii, palm_jj, palm_w_horiz)
+ SUBROUTINE compute_horizontal_interp_weights(cosmo_lat, cosmo_lon,         &
+    palm_clat, palm_clon, palm_ii, palm_jj, palm_w_horiz)
        
-       REAL(dp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
-       REAL(dp)                                   ::  cosmo_dxi, cosmo_dyi
-       REAL(dp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
-       INTEGER, DIMENSION(0:,0:,1:), INTENT(IN)   ::  palm_ii, palm_jj
-
-       REAL(dp), DIMENSION(0:,0:,1:), INTENT(OUT) ::  palm_w_horiz
-
-       REAL(dp) ::  wl, wp
-       INTEGER  ::  i, j
-
-       cosmo_dxi = 1.0_dp / (cosmo_lon(1) - cosmo_lon(0))
-       cosmo_dyi = 1.0_dp / (cosmo_lat(1) - cosmo_lat(0))
-
-       DO j = 0, UBOUND(palm_clon, 2)
-       DO i = 0, UBOUND(palm_clon, 1)
-      
-!
-!--       weight in lambda direction
-          wl = ( cosmo_lon(palm_ii(i,j,4)) - palm_clon(i,j) ) * cosmo_dxi
-
-!
-!--       weight in phi direction
-          wp = ( cosmo_lat(palm_jj(i,j,2)) - palm_clat(i,j) ) * cosmo_dyi
-
-          IF (wl > 1.0_dp .OR. wl < 0.0_dp)  THEN
-              message = "Horizontal weight wl = " // TRIM(real_to_str(wl)) //   &
-                        " is out bounds."
-              CALL inifor_abort('compute_horizontal_interp_weights', message)
-          ENDIF
-          IF (wp > 1.0_dp .OR. wp < 0.0_dp)  THEN
-              message = "Horizontal weight wp = " // TRIM(real_to_str(wp)) //   &
-                        " is out bounds."
-              CALL inifor_abort('compute_horizontal_interp_weights', message)
-          ENDIF
-
-          palm_w_horiz(i,j,1) = wl * wp
-          palm_w_horiz(i,j,2) = wl * (1.0_dp - wp)
-          palm_w_horiz(i,j,3) = (1.0_dp - wl) * (1.0_dp - wp)
-          palm_w_horiz(i,j,4) = 1.0_dp - SUM( palm_w_horiz(i,j,1:3) )
-
-       ENDDO
-       ENDDO
+    REAL(wp), DIMENSION(0:), INTENT(IN)        ::  cosmo_lat, cosmo_lon
+    REAL(wp)                                   ::  cosmo_dxi, cosmo_dyi
+    REAL(wp), DIMENSION(0:,0:), INTENT(IN)     ::  palm_clat, palm_clon
+    INTEGER, DIMENSION(0:,0:,1:), INTENT(IN)   ::  palm_ii, palm_jj
+
+    REAL(wp), DIMENSION(0:,0:,1:), INTENT(OUT) ::  palm_w_horiz
+
+    REAL(wp) ::  wlambda, wphi
+    INTEGER  ::  i, j
+
+    cosmo_dxi = 1.0_wp / (cosmo_lon(1) - cosmo_lon(0))
+    cosmo_dyi = 1.0_wp / (cosmo_lat(1) - cosmo_lat(0))
+
+    DO  j = 0, UBOUND(palm_clon, 2)
+    DO  i = 0, UBOUND(palm_clon, 1)
+    
+!
+!--    weight in lambda direction
+       wlambda = ( cosmo_lon(palm_ii(i,j,4)) - palm_clon(i,j) ) * cosmo_dxi
+
+!
+!--    weight in phi direction
+       wphi = ( cosmo_lat(palm_jj(i,j,2)) - palm_clat(i,j) ) * cosmo_dyi
+
+       IF (wlambda > 1.0_wp .OR. wlambda < 0.0_wp)  THEN
+           message = "Horizontal weight wlambda = " // TRIM(real_to_str(wlambda)) //   &
+                     " is out bounds."
+           CALL inifor_abort('compute_horizontal_interp_weights', message)
+       ENDIF
+       IF (wphi > 1.0_wp .OR. wphi < 0.0_wp)  THEN
+           message = "Horizontal weight wphi = " // TRIM(real_to_str(wphi)) //   &
+                     " is out bounds."
+           CALL inifor_abort('compute_horizontal_interp_weights', message)
+       ENDIF
+
+       palm_w_horiz(i,j,1) = wlambda * wphi
+       palm_w_horiz(i,j,2) = wlambda * (1.0_wp - wphi)
+       palm_w_horiz(i,j,3) = (1.0_wp - wlambda) * (1.0_wp - wphi)
+       palm_w_horiz(i,j,4) = 1.0_wp - SUM( palm_w_horiz(i,j,1:3) )
+
+    ENDDO
+    ENDDO
        
-    END SUBROUTINE compute_horizontal_interp_weights
+ END SUBROUTINE compute_horizontal_interp_weights
 
 
@@ -1311,18 +1316,18 @@
 !> which means the first centre point has to be omitted and is set to zero.
 !------------------------------------------------------------------------------!
-    SUBROUTINE centre_velocities(u_face, v_face, u_centre, v_centre)
-       REAL(dp), DIMENSION(0:,0:,0:), INTENT(IN)  ::  u_face, v_face
-       REAL(dp), DIMENSION(0:,0:,0:), INTENT(OUT) ::  u_centre, v_centre
-       INTEGER ::  nx, ny
-
-       nx = UBOUND(u_face, 1)
-       ny = UBOUND(u_face, 2)
-
-       u_centre(0,:,:)  = 0.0_dp
-       u_centre(1:,:,:) = 0.5_dp * ( u_face(0:nx-1,:,:) + u_face(1:,:,:) )
-
-       v_centre(:,0,:)  = 0.0_dp
-       v_centre(:,1:,:) = 0.5_dp * ( v_face(:,0:ny-1,:) + v_face(:,1:,:) )
-    END SUBROUTINE centre_velocities
+ SUBROUTINE centre_velocities(u_face, v_face, u_centre, v_centre)
+    REAL(wp), DIMENSION(0:,0:,0:), INTENT(IN)  ::  u_face, v_face
+    REAL(wp), DIMENSION(0:,0:,0:), INTENT(OUT) ::  u_centre, v_centre
+    INTEGER ::  nx, ny
+
+    nx = UBOUND(u_face, 1)
+    ny = UBOUND(u_face, 2)
+
+    u_centre(0,:,:)  = 0.0_wp
+    u_centre(1:,:,:) = 0.5_wp * ( u_face(0:nx-1,:,:) + u_face(1:,:,:) )
+
+    v_centre(:,0,:)  = 0.0_wp
+    v_centre(:,1:,:) = 0.5_wp * ( v_face(:,0:ny-1,:) + v_face(:,1:,:) )
+ END SUBROUTINE centre_velocities
 
 
@@ -1332,130 +1337,130 @@
 !> Compute the geographical latitude of a point given in rotated-pole cordinates
 !------------------------------------------------------------------------------!
-    FUNCTION phirot2phi (phirot, rlarot, polphi, polgam)
-    
-       REAL(dp), INTENT (IN) ::  polphi      !< latitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  phirot      !< latitude in the rotated system
-       REAL(dp), INTENT (IN) ::  rlarot      !< longitude in the rotated system
-       REAL(dp), INTENT (IN) ::  polgam      !< angle between the north poles of the systems
-
-       REAL(dp)              ::  phirot2phi  !< latitude in the geographical system
-       
-       REAL(dp)              ::  zsinpol, zcospol, zphis, zrlas, zarg, zgam
-    
-       zsinpol = SIN(polphi * TO_RADIANS)
-       zcospol = COS(polphi * TO_RADIANS)
-       zphis   = phirot * TO_RADIANS
-
-       IF (rlarot > 180.0_dp)  THEN
-          zrlas = rlarot - 360.0_dp
-       ELSE
-          zrlas = rlarot
-       ENDIF
-       zrlas = zrlas * TO_RADIANS
+ FUNCTION phirot2phi (phirot, rlarot, polphi, polgam)
+ 
+    REAL(wp), INTENT (IN) ::  polphi      !< latitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  phirot      !< latitude in the rotated system
+    REAL(wp), INTENT (IN) ::  rlarot      !< longitude in the rotated system
+    REAL(wp), INTENT (IN) ::  polgam      !< angle between the north poles of the systems
+
+    REAL(wp)              ::  phirot2phi  !< latitude in the geographical system
+    
+    REAL(wp)              ::  zsinpol, zcospol, zphis, zrlas, zarg, zgam
+ 
+    zsinpol = SIN(polphi * TO_RADIANS)
+    zcospol = COS(polphi * TO_RADIANS)
+    zphis   = phirot * TO_RADIANS
+
+    IF (rlarot > 180.0_wp)  THEN
+       zrlas = rlarot - 360.0_wp
+    ELSE
+       zrlas = rlarot
+    ENDIF
+    zrlas = zrlas * TO_RADIANS
+  
+    IF (polgam /= 0.0_wp)  THEN
+       zgam = polgam * TO_RADIANS
+       zarg = zsinpol * SIN (zphis) +                                       &
+              zcospol * COS(zphis) * ( COS(zrlas) * COS(zgam) -             &
+                                       SIN(zgam)  * SIN(zrlas) )
+    ELSE
+       zarg = zcospol * COS (zphis) * COS (zrlas) + zsinpol * SIN (zphis)
+    ENDIF
+   
+    phirot2phi = ASIN (zarg) * TO_DEGREES
+ 
+ END FUNCTION phirot2phi
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the geographical latitude of a point given in rotated-pole cordinates
+!------------------------------------------------------------------------------!
+ FUNCTION phi2phirot (phi, rla, polphi, pollam)
+ 
+    REAL(wp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  phi    !< latitude in the geographical system
+    REAL(wp), INTENT (IN) ::  rla    !< longitude in the geographical system
+    
+    REAL(wp) ::  phi2phirot          !< longitude in the rotated system
+    
+    REAL(wp) ::  zsinpol, zcospol, zlampol, zphi, zrla, zarg1, zarg2, zrla1
+    
+    zsinpol = SIN(polphi * TO_RADIANS)
+    zcospol = COS(polphi * TO_RADIANS)
+    zlampol = pollam * TO_RADIANS
+    zphi    = phi * TO_RADIANS
+
+    IF (rla > 180.0_wp)  THEN
+       zrla1 = rla - 360.0_wp
+    ELSE
+       zrla1 = rla
+    ENDIF
+    zrla = zrla1 * TO_RADIANS
+    
+    zarg1 = SIN(zphi) * zsinpol
+    zarg2 = COS(zphi) * zcospol * COS(zrla - zlampol)
+    
+    phi2phirot = ASIN(zarg1 + zarg2) * TO_DEGREES
+ 
+ END FUNCTION phi2phirot
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute the geographical longitude of a point given in rotated-pole cordinates
+!------------------------------------------------------------------------------!
+ FUNCTION rlarot2rla(phirot, rlarot, polphi, pollam, polgam)
+ 
+    REAL(wp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  phirot !< latitude in the rotated system
+    REAL(wp), INTENT (IN) ::  rlarot !< longitude in the rotated system
+    REAL(wp), INTENT (IN) ::  polgam !< angle between the north poles of the systems
+    
+    REAL(wp) ::  rlarot2rla          !< latitude in the geographical system
+    
+    REAL(wp) ::  zsinpol, zcospol, zlampol, zphis, zrlas, zarg1, zarg2, zgam
+    
+    zsinpol = SIN(TO_RADIANS * polphi)
+    zcospol = COS(TO_RADIANS * polphi)
+    zlampol = TO_RADIANS * pollam
+    zphis   = TO_RADIANS * phirot
+
+    IF (rlarot > 180.0_wp)  THEN
+       zrlas = rlarot - 360.0_wp
+    ELSE
+       zrlas = rlarot
+    ENDIF
+    zrlas   = TO_RADIANS * zrlas
+   
+    IF (polgam /= 0.0_wp)  THEN
+       zgam  = TO_RADIANS * polgam
+       zarg1 = SIN(zlampol) * (zcospol * SIN(zphis) - zsinpol*COS(zphis) *  &
+               (COS(zrlas) * COS(zgam) - SIN(zrlas) * SIN(zgam)) ) -        &
+               COS(zlampol) * COS(zphis) * ( SIN(zrlas) * COS(zgam) +       &
+                                             COS(zrlas) * SIN(zgam) )
+    
+       zarg2 = COS (zlampol) * (zcospol * SIN(zphis) - zsinpol*COS(zphis) * &
+               (COS(zrlas) * COS(zgam) - SIN(zrlas) * SIN(zgam)) ) +        &
+               SIN(zlampol) * COS(zphis) * ( SIN(zrlas) * COS(zgam) +       &
+                                             COS(zrlas) * SIN(zgam) )
+    ELSE
+       zarg1   = SIN (zlampol) * (-zsinpol * COS(zrlas) * COS(zphis)  +     &
+                                   zcospol *              SIN(zphis)) -     &
+                 COS (zlampol) *             SIN(zrlas) * COS(zphis)
+       zarg2   = COS (zlampol) * (-zsinpol * COS(zrlas) * COS(zphis)  +     &
+                                   zcospol *              SIN(zphis)) +     &
+                 SIN (zlampol) *             SIN(zrlas) * COS(zphis)
+    ENDIF
+   
+    IF (zarg2 == 0.0_wp)  zarg2 = 1.0E-20_wp
+   
+    rlarot2rla = ATAN2(zarg1,zarg2) * TO_DEGREES
      
-       IF (polgam /= 0.0_dp)  THEN
-          zgam = polgam * TO_RADIANS
-          zarg = zsinpol * SIN (zphis) +                                       &
-                 zcospol * COS(zphis) * ( COS(zrlas) * COS(zgam) -             &
-                                          SIN(zgam)  * SIN(zrlas) )
-       ELSE
-          zarg = zcospol * COS (zphis) * COS (zrlas) + zsinpol * SIN (zphis)
-       ENDIF
-      
-       phirot2phi = ASIN (zarg) * TO_DEGREES
-    
-    END FUNCTION phirot2phi
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Compute the geographical latitude of a point given in rotated-pole cordinates
-!------------------------------------------------------------------------------!
-    FUNCTION phi2phirot (phi, rla, polphi, pollam)
-    
-       REAL(dp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  phi    !< latitude in the geographical system
-       REAL(dp), INTENT (IN) ::  rla    !< longitude in the geographical system
-       
-       REAL(dp) ::  phi2phirot          !< longitude in the rotated system
-       
-       REAL(dp) ::  zsinpol, zcospol, zlampol, zphi, zrla, zarg1, zarg2, zrla1
-       
-       zsinpol = SIN(polphi * TO_RADIANS)
-       zcospol = COS(polphi * TO_RADIANS)
-       zlampol = pollam * TO_RADIANS
-       zphi    = phi * TO_RADIANS
-
-       IF (rla > 180.0_dp)  THEN
-          zrla1 = rla - 360.0_dp
-       ELSE
-          zrla1 = rla
-       ENDIF
-       zrla = zrla1 * TO_RADIANS
-       
-       zarg1 = SIN(zphi) * zsinpol
-       zarg2 = COS(zphi) * zcospol * COS(zrla - zlampol)
-       
-       phi2phirot = ASIN(zarg1 + zarg2) * TO_DEGREES
-    
-    END FUNCTION phi2phirot
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Compute the geographical longitude of a point given in rotated-pole cordinates
-!------------------------------------------------------------------------------!
-    FUNCTION rlarot2rla(phirot, rlarot, polphi, pollam, polgam)
-    
-       REAL(dp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  phirot !< latitude in the rotated system
-       REAL(dp), INTENT (IN) ::  rlarot !< longitude in the rotated system
-       REAL(dp), INTENT (IN) ::  polgam !< angle between the north poles of the systems
-       
-       REAL(dp) ::  rlarot2rla          !< latitude in the geographical system
-       
-       REAL(dp) ::  zsinpol, zcospol, zlampol, zphis, zrlas, zarg1, zarg2, zgam
-       
-       zsinpol = SIN(TO_RADIANS * polphi)
-       zcospol = COS(TO_RADIANS * polphi)
-       zlampol = TO_RADIANS * pollam
-       zphis   = TO_RADIANS * phirot
-
-       IF (rlarot > 180.0_dp)  THEN
-          zrlas = rlarot - 360.0_dp
-       ELSE
-          zrlas = rlarot
-       ENDIF
-       zrlas   = TO_RADIANS * zrlas
-      
-       IF (polgam /= 0.0_dp)  THEN
-          zgam  = TO_RADIANS * polgam
-          zarg1 = SIN(zlampol) * (zcospol * SIN(zphis) - zsinpol*COS(zphis) *  &
-                  (COS(zrlas) * COS(zgam) - SIN(zrlas) * SIN(zgam)) ) -        &
-                  COS(zlampol) * COS(zphis) * ( SIN(zrlas) * COS(zgam) +       &
-                                                COS(zrlas) * SIN(zgam) )
-       
-          zarg2 = COS (zlampol) * (zcospol * SIN(zphis) - zsinpol*COS(zphis) * &
-                  (COS(zrlas) * COS(zgam) - SIN(zrlas) * SIN(zgam)) ) +        &
-                  SIN(zlampol) * COS(zphis) * ( SIN(zrlas) * COS(zgam) +       &
-                                                COS(zrlas) * SIN(zgam) )
-       ELSE
-          zarg1   = SIN (zlampol) * (-zsinpol * COS(zrlas) * COS(zphis)  +     &
-                                      zcospol *              SIN(zphis)) -     &
-                    COS (zlampol) *             SIN(zrlas) * COS(zphis)
-          zarg2   = COS (zlampol) * (-zsinpol * COS(zrlas) * COS(zphis)  +     &
-                                      zcospol *              SIN(zphis)) +     &
-                    SIN (zlampol) *             SIN(zrlas) * COS(zphis)
-       ENDIF
-      
-       IF (zarg2 == 0.0_dp)  zarg2 = 1.0E-20_dp
-      
-       rlarot2rla = ATAN2(zarg1,zarg2) * TO_DEGREES
-        
-    END FUNCTION rlarot2rla
+ END FUNCTION rlarot2rla
 
 
@@ -1465,41 +1470,41 @@
 !> Compute the rotated-pole longitude of a point given in geographical cordinates
 !------------------------------------------------------------------------------!
-    FUNCTION rla2rlarot ( phi, rla, polphi, pollam, polgam )
-
-       REAL(dp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
-       REAL(dp), INTENT (IN) ::  phi    !< latitude in geographical system
-       REAL(dp), INTENT (IN) ::  rla    !< longitude in geographical system
-       REAL(dp), INTENT (IN) ::  polgam !< angle between the north poles of the systems
-       
-       REAL (KIND=dp) ::  rla2rlarot    !< latitude in the the rotated system
-       
-       REAL (KIND=dp) ::  zsinpol, zcospol, zlampol, zphi, zrla, zarg1, zarg2, zrla1
-       
-       zsinpol = SIN(polphi * TO_RADIANS)
-       zcospol = COS(polphi * TO_RADIANS)
-       zlampol = pollam * TO_RADIANS
-       zphi    = phi * TO_RADIANS
-
-       IF (rla > 180.0_dp)  THEN
-          zrla1 = rla - 360.0_dp
-       ELSE
-          zrla1 = rla
-       ENDIF
-       zrla = zrla1 * TO_RADIANS
-       
-       zarg1 = - SIN (zrla-zlampol) * COS(zphi)
-       zarg2 = - zsinpol * COS(zphi) * COS(zrla-zlampol) + zcospol * SIN(zphi)
-       
-       IF (zarg2 == 0.0_dp)  zarg2 = 1.0E-20_dp
-       
-       rla2rlarot = ATAN2 (zarg1,zarg2) * TO_DEGREES
-       
-       IF (polgam /= 0.0_dp )  THEN
-          rla2rlarot = polgam + rla2rlarot
-          IF (rla2rlarot > 180._dp)  rla2rlarot = rla2rlarot - 360.0_dp
-       ENDIF
-       
-    END FUNCTION rla2rlarot
+ FUNCTION rla2rlarot ( phi, rla, polphi, pollam, polgam )
+
+    REAL(wp), INTENT (IN) ::  polphi !< latitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  pollam !< longitude of the rotated north pole
+    REAL(wp), INTENT (IN) ::  phi    !< latitude in geographical system
+    REAL(wp), INTENT (IN) ::  rla    !< longitude in geographical system
+    REAL(wp), INTENT (IN) ::  polgam !< angle between the north poles of the systems
+    
+    REAL(wp) ::  rla2rlarot    !< latitude in the the rotated system
+    
+    REAL(wp) ::  zsinpol, zcospol, zlampol, zphi, zrla, zarg1, zarg2, zrla1
+    
+    zsinpol = SIN(polphi * TO_RADIANS)
+    zcospol = COS(polphi * TO_RADIANS)
+    zlampol = pollam * TO_RADIANS
+    zphi    = phi * TO_RADIANS
+
+    IF (rla > 180.0_wp)  THEN
+       zrla1 = rla - 360.0_wp
+    ELSE
+       zrla1 = rla
+    ENDIF
+    zrla = zrla1 * TO_RADIANS
+    
+    zarg1 = - SIN (zrla-zlampol) * COS(zphi)
+    zarg2 = - zsinpol * COS(zphi) * COS(zrla-zlampol) + zcospol * SIN(zphi)
+    
+    IF (zarg2 == 0.0_wp)  zarg2 = 1.0E-20_wp
+    
+    rla2rlarot = ATAN2 (zarg1,zarg2) * TO_DEGREES
+    
+    IF (polgam /= 0.0_wp )  THEN
+       rla2rlarot = polgam + rla2rlarot
+       IF (rla2rlarot > 180._wp)  rla2rlarot = rla2rlarot - 360.0_wp
+    ENDIF
+    
+ END FUNCTION rla2rlarot
 
 
